﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Ink;
using System.Windows.Media.Imaging;
using System.IO;
using Microsoft.Xna.Framework.Media;
using Microsoft.Phone.Tasks;
using Microsoft.Phone.Shell;


namespace oekaki
{
    public partial class MainPage : PhoneApplicationPage
    {
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();
        }

        private Stroke currentStroke;

        private void inkPresenter1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (penMode == true)
            {
                currentStroke = new Stroke(e.StylusDevice.GetStylusPoints(inkPresenter1));
                currentStroke.DrawingAttributes.Color = Colors.White;
                currentStroke.DrawingAttributes.Width = 5;
                currentStroke.DrawingAttributes.Height = 5;
                inkPresenter1.Strokes.Add(currentStroke);
            }
        }

        private void inkPresenter1_MouseMove(object sender, MouseEventArgs e)
        {
            if (penMode == true)
            {
                currentStroke.StylusPoints.Add(e.StylusDevice.GetStylusPoints(inkPresenter1));
            }
            else
            {
                StylusPointCollection erasePoints = e.StylusDevice.GetStylusPoints(inkPresenter1);
                StrokeCollection hitStrokes = inkPresenter1.Strokes.HitTest(erasePoints);

                foreach (Stroke hitStroke in hitStrokes)
                {
                    Stroke sliceStroke = new Stroke();
                    sliceStroke.DrawingAttributes = hitStroke.DrawingAttributes;

                    foreach (StylusPoint sp in hitStroke.StylusPoints)
                    {
                        sliceStroke.StylusPoints.Add(sp);

                        if (sliceStroke.HitTest(erasePoints))
                        {
                            sliceStroke.StylusPoints.RemoveAt(sliceStroke.StylusPoints.Count - 1);
                            sliceStroke.DrawingAttributes = hitStroke.DrawingAttributes;
                            inkPresenter1.Strokes.Add(sliceStroke);

                            sliceStroke = new Stroke();
                            sliceStroke.DrawingAttributes = hitStroke.DrawingAttributes;
                        }
                    }
                    inkPresenter1.Strokes.Add(sliceStroke);
                    inkPresenter1.Strokes.Remove(hitStroke);
                }
            }
        }

        private void ClearButton_Click(object sender, EventArgs e)
        {
            inkPresenter1.Strokes.Clear();
        }

        public bool penMode = true;
        private void PenButtton_Click(object sender, EventArgs e)
        {
            if (penMode == true)
            {
                penMode = false;
                ((ApplicationBarIconButton)this.ApplicationBar.Buttons[0]).IconUri = new Uri("/icons/appbar.edit.rest.png", UriKind.Relative);
            }
            else
            {
                penMode = true;
                ((ApplicationBarIconButton)this.ApplicationBar.Buttons[0]).IconUri = new Uri("/icons/appbar.erase.rest.png", UriKind.Relative);
            }
        }

        private void SaveButton_Click(object sender, EventArgs e)
        {
            WriteableBitmap bmp = new WriteableBitmap(inkPresenter1, null);
            MemoryStream stream = new MemoryStream();
            bmp.SaveJpeg(stream, bmp.PixelWidth, bmp.PixelHeight, 0, 80);
            using (MediaLibrary mediaLib = new MediaLibrary())
            {
                mediaLib.SavePicture("PaintTest", stream.ToArray());
            }
            MessageBox.Show("保存しました");
        }

        private void LoadButton_Click(object sender, EventArgs e)
        {
            PhotoChooserTask photo = new PhotoChooserTask();
            photo.Completed += new EventHandler<PhotoResult>(photo_Completed);
            photo.Show();
        }

        void photo_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                BitmapImage bmp = new BitmapImage();
                bmp.SetSource(e.ChosenPhoto);
                ImageBrush imageBrush = new ImageBrush();
                imageBrush.Stretch = Stretch.UniformToFill;
                imageBrush.ImageSource = bmp;

                inkPresenter1.Background = imageBrush;
            }
        }
    }
}
